diff -Naur WebKit-r41128/WebCore/css/CSSPrimitiveValueMappings.h WebKit-r41128-nx/WebCore/css/CSSPrimitiveValueMappings.h
--- WebKit-r41128/WebCore/css/CSSPrimitiveValueMappings.h	2009-02-16 04:14:50.000000000 -0500
+++ WebKit-r41128-nx/WebCore/css/CSSPrimitiveValueMappings.h	2009-02-23 16:01:26.617005950 -0500
@@ -1676,72 +1676,6 @@
     }
 }
 
-template<> inline CSSPrimitiveValue::CSSPrimitiveValue(EPointerEvents e)
-    : m_type(CSS_IDENT)
-{
-    switch (e) {
-        case PE_NONE:
-            m_value.ident = CSSValueNone;
-            break;
-        case PE_STROKE:
-            m_value.ident = CSSValueStroke;
-            break;
-        case PE_FILL:
-            m_value.ident = CSSValueFill;
-            break;
-        case PE_PAINTED:
-            m_value.ident = CSSValuePainted;
-            break;
-        case PE_VISIBLE:
-            m_value.ident = CSSValueVisible;
-            break;
-        case PE_VISIBLE_STROKE:
-            m_value.ident = CSSValueVisiblestroke;
-            break;
-        case PE_VISIBLE_FILL:
-            m_value.ident = CSSValueVisiblefill;
-            break;
-        case PE_VISIBLE_PAINTED:
-            m_value.ident = CSSValueVisiblepainted;
-            break;
-        case PE_AUTO:
-            m_value.ident = CSSValueAuto;
-            break;
-        case PE_ALL:
-            m_value.ident = CSSValueAll;
-            break;
-    }
-}
-
-template<> inline CSSPrimitiveValue::operator EPointerEvents() const
-{
-    switch (m_value.ident) {
-        case CSSValueAll:
-            return PE_ALL;
-        case CSSValueAuto:
-            return PE_AUTO;
-        case CSSValueNone:
-            return PE_NONE;
-        case CSSValueVisiblepainted:
-            return PE_VISIBLE_PAINTED;
-        case CSSValueVisiblefill:
-            return PE_VISIBLE_FILL;
-        case CSSValueVisiblestroke:
-            return PE_VISIBLE_STROKE;
-        case CSSValueVisible:
-            return PE_VISIBLE;
-        case CSSValuePainted:
-            return PE_PAINTED;
-        case CSSValueFill:
-            return PE_FILL;
-        case CSSValueStroke:
-            return PE_STROKE;
-        default:
-            ASSERT_NOT_REACHED();
-            return PE_ALL;
-    }
-}
-
 #if ENABLE(SVG)
 
 template<> inline CSSPrimitiveValue::CSSPrimitiveValue(LineCap e)
@@ -2078,6 +2012,76 @@
     }
 }
 
+#endif
+
+template<> inline CSSPrimitiveValue::CSSPrimitiveValue(EPointerEvents e)
+    : m_type(CSS_IDENT)
+{
+    switch (e) {
+        case PE_NONE:
+            m_value.ident = CSSValueNone;
+            break;
+        case PE_STROKE:
+            m_value.ident = CSSValueStroke;
+            break;
+        case PE_FILL:
+            m_value.ident = CSSValueFill;
+            break;
+        case PE_PAINTED:
+            m_value.ident = CSSValuePainted;
+            break;
+        case PE_VISIBLE:
+            m_value.ident = CSSValueVisible;
+            break;
+        case PE_VISIBLE_STROKE:
+            m_value.ident = CSSValueVisiblestroke;
+            break;
+        case PE_VISIBLE_FILL:
+            m_value.ident = CSSValueVisiblefill;
+            break;
+        case PE_VISIBLE_PAINTED:
+            m_value.ident = CSSValueVisiblepainted;
+            break;
+        case PE_AUTO:
+            m_value.ident = CSSValueAuto;
+            break;
+        case PE_ALL:
+            m_value.ident = CSSValueAll;
+            break;
+    }
+}
+
+template<> inline CSSPrimitiveValue::operator EPointerEvents() const
+{
+    switch (m_value.ident) {
+        case CSSValueAll:
+            return PE_ALL;
+        case CSSValueAuto:
+            return PE_AUTO;
+        case CSSValueNone:
+            return PE_NONE;
+        case CSSValueVisiblepainted:
+            return PE_VISIBLE_PAINTED;
+        case CSSValueVisiblefill:
+            return PE_VISIBLE_FILL;
+        case CSSValueVisiblestroke:
+            return PE_VISIBLE_STROKE;
+        case CSSValueVisible:
+            return PE_VISIBLE;
+        case CSSValuePainted:
+            return PE_PAINTED;
+        case CSSValueFill:
+            return PE_FILL;
+        case CSSValueStroke:
+            return PE_STROKE;
+        default:
+            ASSERT_NOT_REACHED();
+            return PE_ALL;
+    }
+}
+
+#if ENABLE(SVG)
+
 template<> inline CSSPrimitiveValue::CSSPrimitiveValue(EShapeRendering e)
     : m_type(CSS_IDENT)
 {
diff -Naur WebKit-r41128/WebCore/GNUmakefile.am WebKit-r41128-nx/WebCore/GNUmakefile.am
--- WebKit-r41128/WebCore/GNUmakefile.am	2009-02-20 22:38:13.000000000 -0500
+++ WebKit-r41128-nx/WebCore/GNUmakefile.am	2009-02-23 16:01:26.621007950 -0500
@@ -1447,14 +1447,9 @@
 	WebCore/platform/text/StringImpl.cpp \
 	WebCore/platform/text/StringImpl.h \
 	WebCore/platform/text/TextBoundaries.h \
-	WebCore/platform/text/TextBoundariesICU.cpp \
 	WebCore/platform/text/TextBreakIterator.h \
-	WebCore/platform/text/TextBreakIteratorICU.cpp \
-	WebCore/platform/text/TextBreakIteratorInternalICU.h \
 	WebCore/platform/text/TextCodec.cpp \
 	WebCore/platform/text/TextCodec.h \
-	WebCore/platform/text/TextCodecICU.cpp \
-	WebCore/platform/text/TextCodecICU.h \
 	WebCore/platform/text/TextCodecLatin1.cpp \
 	WebCore/platform/text/TextCodecLatin1.h \
 	WebCore/platform/text/TextCodecUTF16.cpp \
@@ -1793,8 +1788,31 @@
 	WebCore/platform/image-decoders/png/PNGImageDecoder.cpp \
 	WebCore/platform/image-decoders/png/PNGImageDecoder.h \
 	WebCore/platform/image-decoders/xbm/XBMImageDecoder.cpp \
-	WebCore/platform/image-decoders/xbm/XBMImageDecoder.h \
+	WebCore/platform/image-decoders/xbm/XBMImageDecoder.h
+
+# ----
+# icu unicode backend
+# ----
+if USE_ICU_UNICODE
+webcoregtk_sources += \
+	WebCore/platform/text/TextCodecICU.cpp \
+	WebCore/platform/text/TextCodecICU.h \
+	WebCore/platform/text/TextBoundariesICU.cpp \
+	WebCore/platform/text/TextBreakIteratorICU.cpp \
+	WebCore/platform/text/TextBreakIteratorInternalICU.h \
 	WebCore/platform/text/gtk/TextBreakIteratorInternalICUGtk.cpp
+endif # USE_ICU_UNICODE
+
+# ----
+# glib unicode backend
+# ----
+if USE_GLIB_UNICODE
+webcoregtk_sources += \
+	WebCore/platform/text/gtk/TextCodecGtk.cpp \
+	WebCore/platform/text/gtk/TextCodecGtk.h \
+	WebCore/platform/text/gtk/TextBoundariesGtk.cpp \
+	WebCore/platform/text/gtk/TextBreakIteratorGtk.cpp
+endif
 
 # ----
 # curl http backend
diff -Naur WebKit-r41128/WebCore/html/HTMLInputElement.cpp WebKit-r41128-nx/WebCore/html/HTMLInputElement.cpp
--- WebKit-r41128/WebCore/html/HTMLInputElement.cpp	2009-02-16 02:39:40.000000000 -0500
+++ WebKit-r41128-nx/WebCore/html/HTMLInputElement.cpp	2009-02-23 16:01:26.660124510 -0500
@@ -173,7 +173,7 @@
 
 bool HTMLInputElement::shouldUseInputMethod() const
 {
-    return m_type == TEXT || m_type == SEARCH || m_type == ISINDEX;
+    return m_type == TEXT || m_type == SEARCH || m_type == ISINDEX || m_type == PASSWORD;
 }
 
 void HTMLInputElement::dispatchFocusEvent()
diff -Naur WebKit-r41128/WebCore/loader/EmptyClients.h WebKit-r41128-nx/WebCore/loader/EmptyClients.h
--- WebKit-r41128/WebCore/loader/EmptyClients.h	2009-02-15 03:48:47.000000000 -0500
+++ WebKit-r41128-nx/WebCore/loader/EmptyClients.h	2009-02-23 16:01:26.696007910 -0500
@@ -182,6 +182,7 @@
     virtual Frame* dispatchCreatePage() { return 0; }
     virtual void dispatchShow() { }
 
+    virtual bool dispatchDecidePolicyForNetworkRequest(const ResourceRequest&) { return true; }
     virtual void dispatchDecidePolicyForMIMEType(FramePolicyFunction, const String&, const ResourceRequest&) { }
     virtual void dispatchDecidePolicyForNewWindowAction(FramePolicyFunction, const NavigationAction&, const ResourceRequest&, PassRefPtr<FormState>, const String&) { }
     virtual void dispatchDecidePolicyForNavigationAction(FramePolicyFunction, const NavigationAction&, const ResourceRequest&, PassRefPtr<FormState>) { }
diff -Naur WebKit-r41128/WebCore/loader/FrameLoaderClient.h WebKit-r41128-nx/WebCore/loader/FrameLoaderClient.h
--- WebKit-r41128/WebCore/loader/FrameLoaderClient.h	2009-02-15 03:48:47.000000000 -0500
+++ WebKit-r41128-nx/WebCore/loader/FrameLoaderClient.h	2009-02-23 16:01:26.728007310 -0500
@@ -126,6 +126,7 @@
         virtual Frame* dispatchCreatePage() = 0;
         virtual void dispatchShow() = 0;
 
+        virtual bool dispatchDecidePolicyForNetworkRequest(const ResourceRequest&) = 0;
         virtual void dispatchDecidePolicyForMIMEType(FramePolicyFunction, const String& MIMEType, const ResourceRequest&) = 0;
         virtual void dispatchDecidePolicyForNewWindowAction(FramePolicyFunction, const NavigationAction&, const ResourceRequest&, PassRefPtr<FormState>, const String& frameName) = 0;
         virtual void dispatchDecidePolicyForNavigationAction(FramePolicyFunction, const NavigationAction&, const ResourceRequest&, PassRefPtr<FormState>) = 0;
diff -Naur WebKit-r41128/WebCore/loader/loader.cpp WebKit-r41128-nx/WebCore/loader/loader.cpp
--- WebKit-r41128/WebCore/loader/loader.cpp	2009-02-15 03:48:47.000000000 -0500
+++ WebKit-r41128-nx/WebCore/loader/loader.cpp	2009-02-23 16:01:26.762099190 -0500
@@ -49,7 +49,7 @@
 #if REQUEST_MANAGEMENT_ENABLED
 // Match the parallel connection count used by the networking layer
 // FIXME should not hardcode something like this
-static const unsigned maxRequestsInFlightPerHost = 4;
+static const unsigned maxRequestsInFlightPerHost = 8;
 // Having a limit might still help getting more important resources first
 static const unsigned maxRequestsInFlightForNonHTTPProtocols = 20;
 #else
diff -Naur WebKit-r41128/WebCore/loader/MainResourceLoader.cpp WebKit-r41128-nx/WebCore/loader/MainResourceLoader.cpp
--- WebKit-r41128/WebCore/loader/MainResourceLoader.cpp	2009-02-15 03:48:47.000000000 -0500
+++ WebKit-r41128-nx/WebCore/loader/MainResourceLoader.cpp	2009-02-23 16:01:26.793004990 -0500
@@ -219,9 +219,12 @@
             return;
         }
         frameLoader()->client()->download(m_handle.get(), request(), m_handle.get()->request(), r);
+        // CURL reuses the same ResourceHandle to download the file, so we cannot close it.
+#if !USE(CURL)
         // It might have gone missing
         if (frameLoader())
             receivedError(interruptionForPolicyChangeError());
+#endif
         return;
 
     case PolicyIgnore:
diff -Naur WebKit-r41128/WebCore/loader/ResourceLoader.cpp WebKit-r41128-nx/WebCore/loader/ResourceLoader.cpp
--- WebKit-r41128/WebCore/loader/ResourceLoader.cpp	2009-01-21 00:14:18.000000000 -0500
+++ WebKit-r41128-nx/WebCore/loader/ResourceLoader.cpp	2009-02-23 16:01:26.828006590 -0500
@@ -29,10 +29,12 @@
 
 #include "config.h"
 #include "ResourceLoader.h"
+#include "CString.h"
 
 #include "DocumentLoader.h"
 #include "Frame.h"
 #include "FrameLoader.h"
+#include "FrameLoaderClient.h"
 #include "Page.h"
 #include "ProgressTracker.h"
 #include "ResourceHandle.h"
@@ -115,6 +117,11 @@
         return false;
     }
     
+    if (!frameLoader()->client()->dispatchDecidePolicyForNetworkRequest(r)) {
+        didFail(frameLoader()->blockedError(clientRequest));
+        return false;
+    }
+
     if (m_documentLoader->scheduleArchiveLoad(this, clientRequest, r.url()))
         return true;
     
diff -Naur WebKit-r41128/WebCore/platform/ContextMenu.cpp WebKit-r41128-nx/WebCore/platform/ContextMenu.cpp
--- WebKit-r41128/WebCore/platform/ContextMenu.cpp	2009-02-15 03:48:48.000000000 -0500
+++ WebKit-r41128-nx/WebCore/platform/ContextMenu.cpp	2009-02-26 02:13:04.377007430 -0500
@@ -297,12 +297,12 @@
                 }
                 appendItem(CopyItem);
             } else {
-#if PLATFORM(GTK)
+/*#if PLATFORM(GTK)
                 appendItem(BackItem);
                 appendItem(ForwardItem);
                 appendItem(StopItem);
                 appendItem(ReloadItem);
-#else
+#else*/
                 if (loader->canGoBackOrForward(-1))
                     appendItem(BackItem);
 
@@ -315,7 +315,7 @@
                     appendItem(StopItem);
                 else
                     appendItem(ReloadItem);
-#endif
+/*#endif*/
 
                 if (frame->page() && frame != frame->page()->mainFrame())
                     appendItem(OpenFrameItem);
@@ -586,7 +586,7 @@
         case ContextMenuItemTagCheckSpellingWhileTyping:
             shouldCheck = frame->editor()->isContinuousSpellCheckingEnabled();
             break;
-#if PLATFORM(GTK)
+/*#if PLATFORM(GTK)
         case ContextMenuItemTagGoBack:
             shouldEnable = frame->loader()->canGoBackOrForward(-1);
             break;
@@ -602,13 +602,13 @@
         case ContextMenuItemTagFontMenu:
             shouldEnable = frame->editor()->canEditRichly();
             break;
-#else
+#else*/
         case ContextMenuItemTagGoBack:
         case ContextMenuItemTagGoForward:
         case ContextMenuItemTagStop:
         case ContextMenuItemTagReload:
         case ContextMenuItemTagFontMenu:
-#endif
+/*#endif*/
         case ContextMenuItemTagNoAction:
         case ContextMenuItemTagOpenLinkInNewWindow:
         case ContextMenuItemTagDownloadLinkToDisk:
diff -Naur WebKit-r41128/WebCore/platform/graphics/gtk/SimpleFontDataGtk.cpp WebKit-r41128-nx/WebCore/platform/graphics/gtk/SimpleFontDataGtk.cpp
--- WebKit-r41128/WebCore/platform/graphics/gtk/SimpleFontDataGtk.cpp	2009-02-12 18:01:53.000000000 -0500
+++ WebKit-r41128-nx/WebCore/platform/graphics/gtk/SimpleFontDataGtk.cpp	2009-02-23 16:01:26.860006790 -0500
@@ -39,8 +39,6 @@
 #include "FontDescription.h"
 #include "GlyphBuffer.h"
 #include <cairo.h>
-#include <unicode/uchar.h>
-#include <unicode/unorm.h>
 #include <wtf/MathExtras.h>
 
 namespace WebCore {
diff -Naur WebKit-r41128/WebCore/platform/gtk/gtk2drawing.c WebKit-r41128-nx/WebCore/platform/gtk/gtk2drawing.c
--- WebKit-r41128/WebCore/platform/gtk/gtk2drawing.c	2009-01-27 02:55:34.000000000 -0500
+++ WebKit-r41128-nx/WebCore/platform/gtk/gtk2drawing.c	2009-02-23 16:01:26.864005630 -0500
@@ -1925,7 +1925,7 @@
     /* this is for drawing a prelight box */
     if (state_type == GTK_STATE_PRELIGHT || state_type == GTK_STATE_ACTIVE) {
         gtk_paint_flat_box(style, drawable, GTK_STATE_PRELIGHT,
-                           GTK_SHADOW_ETCHED_OUT, cliprect, widget,
+                           GTK_SHADOW_NONE, cliprect, widget, // ETCHED_OUT 
                            "checkbutton",
                            rect->x, rect->y, rect->width, rect->height);
     }
@@ -2803,7 +2803,7 @@
                 w = gRadiobuttonWidget;
             }
 
-            *left = *top = *right = *bottom = GTK_CONTAINER(w)->border_width;
+            *left = *top = *right = *bottom = 2; //GTK_CONTAINER(w)->border_width;  // In Maemo better use smaller borders?
 
             if (!interior_focus) {
                 *left += (focus_width + focus_pad);
diff -Naur WebKit-r41128/WebCore/platform/gtk/RenderThemeGtk.cpp WebKit-r41128-nx/WebCore/platform/gtk/RenderThemeGtk.cpp
--- WebKit-r41128/WebCore/platform/gtk/RenderThemeGtk.cpp	2009-01-25 22:06:55.000000000 -0500
+++ WebKit-r41128-nx/WebCore/platform/gtk/RenderThemeGtk.cpp	2009-02-23 16:01:26.893005550 -0500
@@ -229,7 +229,7 @@
 
     // Other ports hard-code this to 13, but GTK+ users tend to demand the native look.
     // It could be made a configuration option values other than 13 actually break site compatibility.
-    int length = indicator_size + indicator_spacing;
+    int length = indicator_size + indicator_spacing;  // Check if this helps Maemo rendering
     if (style->width().isIntrinsicOrAuto())
         style->setWidth(Length(length, Fixed));
 
diff -Naur WebKit-r41128/WebCore/platform/KURL.cpp WebKit-r41128-nx/WebCore/platform/KURL.cpp
--- WebKit-r41128/WebCore/platform/KURL.cpp	2009-02-20 22:38:15.000000000 -0500
+++ WebKit-r41128-nx/WebCore/platform/KURL.cpp	2009-02-23 16:01:26.928006870 -0500
@@ -38,6 +38,10 @@
 #include <unicode/uidna.h>
 #elif USE(QT4_UNICODE)
 #include <QUrl>
+#elif USE(GLIB_UNICODE)
+#include <glib.h>
+#include <idna.h>
+#include <wtf/GOwnPtr.h>
 #endif
 
 #include <stdio.h>
@@ -1384,6 +1388,19 @@
 #elif USE(QT4_UNICODE)
     QByteArray result = QUrl::toAce(String(str, strLen));
     buffer.append(result.constData(), result.length());
+#elif USE(GLIB_UNICODE)
+    // first translate to ucs4, libidn is expecting code points 
+    GOwnPtr<gunichar> ucs4Hostname;
+    GOwnPtr<GError> ucs4Err;
+    ucs4Hostname.set(g_utf16_to_ucs4(str, strLen, 0, 0, &ucs4Err.outPtr()));
+    if(ucs4Err)
+        return;
+    char* encodedHostname = 0;
+    int err;
+    err = idna_to_ascii_4z(ucs4Hostname.get(), &encodedHostname, IDNA_ALLOW_UNASSIGNED);
+    if(err == IDNA_SUCCESS)
+        buffer.append(encodedHostname, strlen(encodedHostname));
+    free(encodedHostname);
 #endif
 }
 
diff -Naur WebKit-r41128/WebCore/platform/MIMETypeRegistry.cpp WebKit-r41128-nx/WebCore/platform/MIMETypeRegistry.cpp
--- WebKit-r41128/WebCore/platform/MIMETypeRegistry.cpp	2009-02-20 22:38:15.000000000 -0500
+++ WebKit-r41128-nx/WebCore/platform/MIMETypeRegistry.cpp	2009-02-23 16:01:26.961008590 -0500
@@ -186,6 +186,7 @@
         "text/html",
         "text/xml",
         "text/xsl",
+/* Mozilla asks before opening text/plain */
         "text/plain",
         "text/",
         "application/xml",
diff -Naur WebKit-r41128/WebCore/platform/network/curl/ResourceHandleCurl.cpp WebKit-r41128-nx/WebCore/platform/network/curl/ResourceHandleCurl.cpp
--- WebKit-r41128/WebCore/platform/network/curl/ResourceHandleCurl.cpp	2009-01-21 00:14:21.000000000 -0500
+++ WebKit-r41128-nx/WebCore/platform/network/curl/ResourceHandleCurl.cpp	2009-02-23 16:01:26.984007150 -0500
@@ -103,7 +103,10 @@
 
 bool ResourceHandle::start(Frame* frame)
 {
-    ASSERT(frame);
+    /*
+     * The frame could be null is the ResourceHandle is not associated
+     * to any Frame, i.e. if we are downloading a file.
+     */
     ResourceHandleManager::sharedInstance()->add(this);
     return true;
 }
diff -Naur WebKit-r41128/WebCore/platform/network/curl/ResourceHandleManager.cpp WebKit-r41128-nx/WebCore/platform/network/curl/ResourceHandleManager.cpp
--- WebKit-r41128/WebCore/platform/network/curl/ResourceHandleManager.cpp	2009-01-21 00:14:21.000000000 -0500
+++ WebKit-r41128-nx/WebCore/platform/network/curl/ResourceHandleManager.cpp	2009-02-23 16:01:27.012004190 -0500
@@ -62,7 +62,7 @@
 
 ResourceHandleManager::ResourceHandleManager()
     : m_downloadTimer(this, &ResourceHandleManager::downloadTimerCallback)
-    , m_cookieJarFileName(0)
+    , m_cookieJarFileName("/home/user/.webkitcookies")
     , m_runningJobs(0)
 {
     curl_global_init(CURL_GLOBAL_ALL);
@@ -175,9 +175,21 @@
         CURLcode err;
 
         double contentLength = 0;
-        err = curl_easy_getinfo(h, CURLINFO_CONTENT_LENGTH_DOWNLOAD, &contentLength);
+	String cLength = d->m_response.httpHeaderField("Content-Length");
+	
+        int index = cLength.find(':');
+	if (index == -1) {
+	    index = 0;
+        }
+    
+	contentLength = cLength.substring(0, index-1).stripWhiteSpace().toDouble();
         d->m_response.setExpectedContentLength(static_cast<long long int>(contentLength));
 
+/* CURL doesn't seem to get Content-Length properly */
+//        err = curl_easy_getinfo(h, CURLINFO_CONTENT_LENGTH_DOWNLOAD, &contentLength);
+//        if (CURLE_OK == err)
+//            d->m_response.setExpectedContentLength(static_cast<long long int>(contentLength));
+            
         const char* hdr;
         err = curl_easy_getinfo(h, CURLINFO_EFFECTIVE_URL, &hdr);
         d->m_response.setUrl(KURL(hdr));
@@ -504,6 +516,9 @@
     String mimeType = extractMIMETypeFromMediaType(mediaType);
     String charset = extractCharsetFromMediaType(mediaType);
 
+    if (mimeType.isEmpty())
+        mimeType = "application/octet-stream";
+        
     ResourceResponse response;
     response.setMimeType(mimeType);
 
@@ -637,10 +652,11 @@
     curl_easy_setopt(d->m_handle, CURLOPT_MAXREDIRS, 10);
     curl_easy_setopt(d->m_handle, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
     curl_easy_setopt(d->m_handle, CURLOPT_SHARE, m_curlShareHandle);
+    curl_easy_setopt(d->m_handle, CURLOPT_CAPATH, "/etc/ssl/certs");
     curl_easy_setopt(d->m_handle, CURLOPT_DNS_CACHE_TIMEOUT, 60 * 5); // 5 minutes
     // FIXME: Enable SSL verification when we have a way of shipping certs
     // and/or reporting SSL errors to the user.
-    if (ignoreSSLErrors)
+//    if (ignoreSSLErrors)
         curl_easy_setopt(d->m_handle, CURLOPT_SSL_VERIFYPEER, false);
     // enable gzip and deflate through Accept-Encoding:
     curl_easy_setopt(d->m_handle, CURLOPT_ENCODING, "");
diff -Naur WebKit-r41128/WebCore/platform/network/soup/ResourceHandleSoup.cpp WebKit-r41128-nx/WebCore/platform/network/soup/ResourceHandleSoup.cpp
--- WebKit-r41128/WebCore/platform/network/soup/ResourceHandleSoup.cpp	2009-02-20 22:38:15.000000000 -0500
+++ WebKit-r41128-nx/WebCore/platform/network/soup/ResourceHandleSoup.cpp	2009-02-23 16:01:27.044005230 -0500
@@ -475,9 +475,12 @@
 {
     ASSERT(!d->m_msg);
 
-    // If we are no longer attached to a Page, this must be an attempted load from an
-    // onUnload handler, so let's just block it.
-    if (!frame->page())
+
+    /* The frame could be null is the ResourceHandle is not associated to any
+     * Frame, i.e. if we are downloading a file.
+     * If the frame is not null but the page is null this must be an attempted
+     * load from an onUnload handler, so let's just block it. */
+    if (frame && !frame->page())
         return false;
 
     KURL url = request().url();
diff -Naur WebKit-r41128/WebCore/platform/ScrollView.cpp WebKit-r41128-nx/WebCore/platform/ScrollView.cpp
--- WebKit-r41128/WebCore/platform/ScrollView.cpp	2009-02-13 00:50:35.000000000 -0500
+++ WebKit-r41128-nx/WebCore/platform/ScrollView.cpp	2009-02-23 16:01:27.076006870 -0500
@@ -281,6 +281,7 @@
 
 void ScrollView::setScrollPosition(const IntPoint& scrollPoint)
 {
+#if 0
     if (prohibitsScrolling())
         return;
 
@@ -288,12 +289,13 @@
         platformSetScrollPosition(scrollPoint);
         return;
     }
+#endif
 
     IntPoint newScrollPosition = scrollPoint.shrunkTo(maximumScrollPosition());
     newScrollPosition.clampNegativeToZero();
 
-    if (newScrollPosition == scrollPosition())
-        return;
+    //if (newScrollPosition == scrollPosition())
+    //    return;
 
     updateScrollbars(IntSize(newScrollPosition.x(), newScrollPosition.y()));
 }
@@ -316,7 +318,8 @@
 void ScrollView::updateScrollbars(const IntSize& desiredOffset)
 {
     // Don't allow re-entrancy into this function.
-    if (m_inUpdateScrollbars || prohibitsScrolling() || platformWidget())
+    //if (m_inUpdateScrollbars || prohibitsScrolling() || platformWidget())
+    if (m_inUpdateScrollbars || platformWidget())
         return;
 
     m_inUpdateScrollbars = true;
diff -Naur WebKit-r41128/WebCore/platform/text/gtk/TextBoundariesGtk.cpp WebKit-r41128-nx/WebCore/platform/text/gtk/TextBoundariesGtk.cpp
--- WebKit-r41128/WebCore/platform/text/gtk/TextBoundariesGtk.cpp	1969-12-31 19:00:00.000000000 -0500
+++ WebKit-r41128-nx/WebCore/platform/text/gtk/TextBoundariesGtk.cpp	2009-02-23 16:01:27.112006950 -0500
@@ -0,0 +1,77 @@
+/*
+ * Copyright (C) 2006, 2007 Apple Inc.  All rights reserved.
+ * Copyright (C) 2008 Jürg Billeter <j@bitron.ch>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY APPLE COMPUTER, INC. ``AS IS'' AND ANY
+ * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE COMPUTER, INC. OR
+ * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
+ * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
+ * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */
+
+#include "config.h"
+#include "TextBoundaries.h"
+
+#include <glib.h>
+
+#include "StringImpl.h"
+#include "TextBreakIterator.h"
+
+namespace WebCore {
+
+int findNextWordFromIndex(const UChar* chars, int len, int position, bool forward)
+{
+    TextBreakIterator* it = wordBreakIterator(chars, len);
+
+    if (forward) {
+        position = textBreakFollowing(it, position);
+        while (position != TextBreakDone) {
+            // We stop searching when the character preceeding the break
+            // is alphanumeric.
+            if (position < len && g_unichar_isalnum(chars[position - 1]))
+                return position;
+
+            position = textBreakFollowing(it, position);
+        }
+
+        return len;
+    } else {
+        position = textBreakPreceding(it, position);
+        while (position != TextBreakDone) {
+            // We stop searching when the character following the break
+            // is alphanumeric.
+            if (position > 0 && g_unichar_isalnum(chars[position]))
+                return position;
+
+            position = textBreakPreceding(it, position);
+        }
+
+        return 0;
+    }
+}
+
+void findWordBoundary(const UChar* chars, int len, int position, int* start, int* end)
+{
+    TextBreakIterator* it = wordBreakIterator(chars, len);
+    *end = textBreakFollowing(it, position);
+    if (*end < 0)
+        *end = textBreakLast(it);
+    *start = textBreakPrevious(it);
+}
+
+} // namespace WebCore
